]> arthur.barton.de Git - bup.git/blob - Makefile
_helpers: fix module init, and get it at least building with py3
[bup.git] / Makefile
1
2 SHELL := bash
3 .DEFAULT_GOAL := all
4
5 # See config/config.vars.in (sets bup_python, among other things)
6 include config/config.vars
7
8 pf := set -o pipefail
9
10 define isok
11   && echo " ok" || echo " no"
12 endef
13
14 # If ok, strip trailing " ok" and return the output, otherwise, error
15 define shout
16 $(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
17 endef
18
19 sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
20 sampledata_rev := \
21   $(call shout,$(sampledata_rev),Could not parse sampledata revision)
22
23 current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
24
25 os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
26 os := $(call shout,$(os),Unable to determine OS)
27
28 CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
29 CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
30 SOEXT:=.so
31
32 ifeq ($(os),CYGWIN)
33   SOEXT:=.dll
34 endif
35
36 ifdef TMPDIR
37   test_tmp := $(TMPDIR)
38 else
39   test_tmp := $(CURDIR)/t/tmp
40 endif
41
42 initial_setup := $(shell ./configure-version --update $(isok))
43 initial_setup := $(call shout,$(initial_setup),Version configuration failed))
44
45 config/config.vars: configure config/configure config/configure.inc \
46   $(wildcard config/*.in)
47         MAKE="$(MAKE)" ./configure
48
49 bup_cmds := cmd/bup-python\
50   $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
51   $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
52
53 bup_deps := bup lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
54
55 all: $(bup_deps) Documentation/all $(current_sampledata)
56
57 bup:
58         ln -s main.py bup
59
60 $(current_sampledata):
61         t/configure-sampledata --setup
62
63 define install-python-bin
64   set -e; \
65   sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
66   chmod 0755 $2;
67 endef
68
69 PANDOC ?= $(shell type -p pandoc)
70
71 ifeq (,$(PANDOC))
72   $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
73   man_md :=
74 else
75   man_md := $(wildcard Documentation/*.md)
76 endif
77
78 man_roff := $(patsubst %.md,%.1,$(man_md))
79 man_html := $(patsubst %.md,%.html,$(man_md))
80
81 INSTALL=install
82 PREFIX=/usr/local
83 MANDIR=$(PREFIX)/share/man
84 DOCDIR=$(PREFIX)/share/doc/bup
85 BINDIR=$(PREFIX)/bin
86 LIBDIR=$(PREFIX)/lib/bup
87
88 dest_mandir := $(DESTDIR)$(MANDIR)
89 dest_docdir := $(DESTDIR)$(DOCDIR)
90 dest_bindir := $(DESTDIR)$(BINDIR)
91 dest_libdir := $(DESTDIR)$(LIBDIR)
92
93 install: all
94         $(INSTALL) -d $(dest_bindir) \
95                 $(dest_libdir)/bup $(dest_libdir)/cmd \
96                 $(dest_libdir)/web $(dest_libdir)/web/static
97         test -z "$(man_roff)" || install -d $(dest_mandir)/man1
98         test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
99         test -z "$(man_html)" || install -d $(dest_docdir)
100         test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
101         $(call install-python-bin,bup,"$(dest_bindir)/bup")
102         set -e; \
103         for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
104           $(call install-python-bin,"$$cmd","$(dest_libdir)/$$cmd") \
105         done
106         $(INSTALL) -pm 0644 \
107                 lib/bup/*.py \
108                 $(dest_libdir)/bup
109         $(INSTALL) -pm 0755 \
110                 lib/bup/*$(SOEXT) \
111                 $(dest_libdir)/bup
112         $(INSTALL) -pm 0644 \
113                 lib/web/static/* \
114                 $(dest_libdir)/web/static/
115         $(INSTALL) -pm 0644 \
116                 lib/web/*.html \
117                 $(dest_libdir)/web/
118
119 config/config.h: config/config.vars
120
121 lib/bup/_helpers$(SOEXT): \
122                 config/config.h \
123                 lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
124         @rm -f $@
125         cd lib/bup && \
126         LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
127         # Make sure there's just the one file we expect before we copy it.
128         find lib/bup/build/* -maxdepth 1 -name '_helpers*$(SOEXT)' \
129           -exec printf 'x\c' '{}' \; | wc -c | xargs test 1 -eq
130         cp lib/bup/build/*/_helpers*$(SOEXT) "$@"
131
132 lib/bup/_checkout.py:
133         @if grep -F '$Format' lib/bup/_release.py \
134             && ! test -e lib/bup/_checkout.py; then \
135           echo "Something has gone wrong; $@ should already exist."; \
136           echo 'Check "./configure-version --update"'; \
137           false; \
138         fi
139
140 t/tmp:
141         mkdir t/tmp
142
143 runtests: runtests-python runtests-cmdline
144
145 # The "pwd -P" here may not be appropriate in the long run, but we
146 # need it until we settle the relevant drecurse/exclusion questions:
147 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
148 runtests-python: all t/tmp
149         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
150           "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
151             | tee -a t/tmp/test-log/$$$$.log
152
153 cmdline_tests := \
154   t/test-ftp \
155   t/test-save-restore \
156   t/test-packsizelimit \
157   t/test-prune-older \
158   t/test-web.sh \
159   t/test-rm.sh \
160   t/test-gc.sh \
161   t/test-main.sh \
162   t/test-list-idx.sh \
163   t/test-index.sh \
164   t/test-split-join.sh \
165   t/test-fuse.sh \
166   t/test-drecurse.sh \
167   t/test-cat-file.sh \
168   t/test-compression.sh \
169   t/test-fsck.sh \
170   t/test-index-clear.sh \
171   t/test-index-check-device.sh \
172   t/test-ls \
173   t/test-ls-remote \
174   t/test-tz.sh \
175   t/test-meta.sh \
176   t/test-on.sh \
177   t/test-restore-map-owner.sh \
178   t/test-restore-single-file.sh \
179   t/test-rm-between-index-and-save.sh \
180   t/test-save-with-valid-parent.sh \
181   t/test-sparse-files.sh \
182   t/test-command-without-init-fails.sh \
183   t/test-redundant-saves.sh \
184   t/test-save-creates-no-unrefs.sh \
185   t/test-save-restore-excludes.sh \
186   t/test-save-strip-graft.sh \
187   t/test-import-duplicity.sh \
188   t/test-import-rdiff-backup.sh \
189   t/test-xdev.sh \
190   t/test.sh
191
192 # For parallel runs.
193 # The "pwd -P" here may not be appropriate in the long run, but we
194 # need it until we settle the relevant drecurse/exclusion questions:
195 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
196 tmp-target-run-test%: all t/tmp
197         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
198           t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
199
200 runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
201
202 stupid:
203         PATH=/bin:/usr/bin $(MAKE) test
204
205 test: all
206         if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
207         mkdir -p t/tmp/test-log
208         ./wvtest watch --no-counts \
209           $(MAKE) runtests-python runtests-cmdline 2>t/tmp/test-log/$$$$.log
210         ./wvtest report t/tmp/test-log/*.log
211
212 check: test
213
214 distcheck: all
215         ./wvtest run t/test-release-archive.sh
216
217 cmd/python-cmd.sh: config/config.vars Makefile
218         printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
219           >> cmd/python-cmd.sh.$$PPID.tmp
220         chmod +x cmd/python-cmd.sh.$$PPID.tmp
221         mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh
222
223 cmd/bup-%: cmd/%-cmd.py
224         rm -f $@
225         ln -s $*-cmd.py $@
226
227 cmd/bup-%: cmd/%-cmd.sh
228         rm -f $@
229         ln -s $*-cmd.sh $@
230
231 .PHONY: Documentation/all
232 Documentation/all: $(man_roff) $(man_html)
233
234 Documentation/substvars: $(bup_deps)
235         echo "s,%BUP_VERSION%,$$(./bup version --tag),g" > $@
236         echo "s,%BUP_DATE%,$$(./bup version --date),g" >> $@
237
238 Documentation/%.1: Documentation/%.md Documentation/substvars
239         $(pf); sed -f Documentation/substvars $< \
240           | $(PANDOC) -s -r markdown -w man -o $@
241
242 Documentation/%.html: Documentation/%.md Documentation/substvars
243         $(pf); sed -f Documentation/substvars $< \
244           | $(PANDOC) -s -r markdown -w html -o $@
245
246 .PHONY: Documentation/clean
247 Documentation/clean:
248         cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
249
250 # update the local 'man' and 'html' branches with pregenerated output files, for
251 # people who don't have pandoc (and maybe to aid in google searches or something)
252 export-docs: Documentation/all
253         git update-ref refs/heads/man origin/man '' 2>/dev/null || true
254         git update-ref refs/heads/html origin/html '' 2>/dev/null || true
255         set -eo pipefail; \
256         GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
257         rm -f $${GIT_INDEX_FILE} && \
258         git add -f Documentation/*.1 && \
259         git update-ref refs/heads/man \
260                 $$(echo "Autogenerated man pages for $$(git describe --always)" \
261                     | git commit-tree $$(git write-tree --prefix=Documentation) \
262                                 -p refs/heads/man) && \
263         rm -f $${GIT_INDEX_FILE} && \
264         git add -f Documentation/*.html && \
265         git update-ref refs/heads/html \
266                 $$(echo "Autogenerated html pages for $$(git describe --always)" \
267                     | git commit-tree $$(git write-tree --prefix=Documentation) \
268                                 -p refs/heads/html)
269
270 # push the pregenerated doc files to origin/man and origin/html
271 push-docs: export-docs
272         git push origin man html
273
274 # import pregenerated doc files from origin/man and origin/html, in case you
275 # don't have pandoc but still want to be able to install the docs.
276 import-docs: Documentation/clean
277         $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
278         $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
279
280 clean: Documentation/clean cmd/bup-python
281         cd config && rm -f *~ .*~ \
282           ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
283         rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
284                 .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
285                 *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
286                 bup bup-* \
287                 randomgen memtest \
288                 testfs.img lib/bup/t/testfs.img
289         if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
290         if test -e t/mnt; then rm -r t/mnt; fi
291         if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
292         # FIXME: migrate these to t/mnt/
293         if test -e lib/bup/t/testfs; \
294           then umount lib/bup/t/testfs || true; fi
295         rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
296         if test -e t/tmp; then t/force-delete t/tmp; fi
297         ./configure-version --clean
298         t/configure-sampledata --clean
299         # Remove last so that cleanup tools can depend on it
300         rm -f cmd/bup-* cmd/python-cmd.sh